diff --git a/usr.bin/nc/socks.c b/usr.bin/nc/socks.c
new file mode 100644
index 0000000000..1b06e0e12d
--- /dev/null
+++ b/usr.bin/nc/socks.c
@@ -0,0 +1,340 @@
+/*	$OpenBSD: socks.c,v 1.21 2015/03/26 21:19:51 tobias Exp $	*/
+
+/*
+ * Copyright (c) 1999 Niklas Hallqvist.  All rights reserved.
+ * Copyright (c) 2004, 2005 Damien Miller.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <err.h>
+#include <errno.h>
+#include <netdb.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <resolv.h>
+#include <readpassphrase.h>
+#include "atomicio.h"
+
+#define SOCKS_PORT	"1080"
+#define HTTP_PROXY_PORT	"3128"
+#define HTTP_MAXHDRS	64
+#define SOCKS_V5	5
+#define SOCKS_V4	4
+#define SOCKS_NOAUTH	0
+#define SOCKS_NOMETHOD	0xff
+#define SOCKS_CONNECT	1
+#define SOCKS_IPV4	1
+#define SOCKS_DOMAIN	3
+#define SOCKS_IPV6	4
+
+int	remote_connect(const char *, const char *, struct addrinfo);
+int	socks_connect(const char *, const char *, struct addrinfo,
+	    const char *, const char *, struct addrinfo, int,
+	    const char *);
+
+static int
+decode_addrport(const char *h, const char *p, struct sockaddr *addr,
+    socklen_t addrlen, int v4only, int numeric)
+{
+	int r;
+	struct addrinfo hints, *res;
+
+	bzero(&hints, sizeof(hints));
+	hints.ai_family = v4only ? PF_INET : PF_UNSPEC;
+	hints.ai_flags = numeric ? AI_NUMERICHOST : 0;
+	hints.ai_socktype = SOCK_STREAM;
+	r = getaddrinfo(h, p, &hints, &res);
+	/* Don't fatal when attempting to convert a numeric address */
+	if (r != 0) {
+		if (!numeric) {
+			errx(1, "getaddrinfo(\"%.64s\", \"%.64s\"): %s", h, p,
+			    gai_strerror(r));
+		}
+		return (-1);
+	}
+	if (addrlen < res->ai_addrlen) {
+		freeaddrinfo(res);
+		errx(1, "internal error: addrlen < res->ai_addrlen");
+	}
+	memcpy(addr, res->ai_addr, res->ai_addrlen);
+	freeaddrinfo(res);
+	return (0);
+}
+
+static int
+proxy_read_line(int fd, char *buf, size_t bufsz)
+{
+	size_t off;
+
+	for(off = 0;;) {
+		if (off >= bufsz)
+			errx(1, "proxy read too long");
+		if (atomicio(read, fd, buf + off, 1) != 1)
+			err(1, "proxy read");
+		/* Skip CR */
+		if (buf[off] == '\r')
+			continue;
+		if (buf[off] == '\n') {
+			buf[off] = '\0';
+			break;
+		}
+		off++;
+	}
+	return (off);
+}
+
+static const char *
+getproxypass(const char *proxyuser, const char *proxyhost)
+{
+	char prompt[512];
+	static char pw[256];
+
+	snprintf(prompt, sizeof(prompt), "Proxy password for %s@%s: ",
+	   proxyuser, proxyhost);
+	if (readpassphrase(prompt, pw, sizeof(pw), RPP_REQUIRE_TTY) == NULL)
+		errx(1, "Unable to read proxy passphrase");
+	return (pw);
+}
+
+int
+socks_connect(const char *host, const char *port,
+    struct addrinfo hints __attribute__ ((__unused__)),
+    const char *proxyhost, const char *proxyport, struct addrinfo proxyhints,
+    int socksv, const char *proxyuser)
+{
+	int proxyfd, r, authretry = 0;
+	size_t hlen, wlen;
+	unsigned char buf[1024];
+	size_t cnt;
+	struct sockaddr_storage addr;
+	struct sockaddr_in *in4 = (struct sockaddr_in *)&addr;
+	struct sockaddr_in6 *in6 = (struct sockaddr_in6 *)&addr;
+	in_port_t serverport;
+	const char *proxypass = NULL;
+
+	if (proxyport == NULL)
+		proxyport = (socksv == -1) ? HTTP_PROXY_PORT : SOCKS_PORT;
+
+	/* Abuse API to lookup port */
+	if (decode_addrport("0.0.0.0", port, (struct sockaddr *)&addr,
+	    sizeof(addr), 1, 1) == -1)
+		errx(1, "unknown port \"%.64s\"", port);
+	serverport = in4->sin_port;
+
+ again:
+	if (authretry++ > 3)
+		errx(1, "Too many authentication failures");
+
+	proxyfd = remote_connect(proxyhost, proxyport, proxyhints);
+
+	if (proxyfd < 0)
+		return (-1);
+
+	if (socksv == 5) {
+		if (decode_addrport(host, port, (struct sockaddr *)&addr,
+		    sizeof(addr), 0, 1) == -1)
+			addr.ss_family = 0; /* used in switch below */
+
+		/* Version 5, one method: no authentication */
+		buf[0] = SOCKS_V5;
+		buf[1] = 1;
+		buf[2] = SOCKS_NOAUTH;
+		cnt = atomicio(vwrite, proxyfd, buf, 3);
+		if (cnt != 3)
+			err(1, "write failed (%zu/3)", cnt);
+
+		cnt = atomicio(read, proxyfd, buf, 2);
+		if (cnt != 2)
+			err(1, "read failed (%zu/3)", cnt);
+
+		if (buf[1] == SOCKS_NOMETHOD)
+			errx(1, "authentication method negotiation failed");
+
+		switch (addr.ss_family) {
+		case 0:
+			/* Version 5, connect: domain name */
+
+			/* Max domain name length is 255 bytes */
+			hlen = strlen(host);
+			if (hlen > 255)
+				errx(1, "host name too long for SOCKS5");
+			buf[0] = SOCKS_V5;
+			buf[1] = SOCKS_CONNECT;
+			buf[2] = 0;
+			buf[3] = SOCKS_DOMAIN;
+			buf[4] = hlen;
+			memcpy(buf + 5, host, hlen);			
+			memcpy(buf + 5 + hlen, &serverport, sizeof serverport);
+			wlen = 7 + hlen;
+			break;
+		case AF_INET:
+			/* Version 5, connect: IPv4 address */
+			buf[0] = SOCKS_V5;
+			buf[1] = SOCKS_CONNECT;
+			buf[2] = 0;
+			buf[3] = SOCKS_IPV4;
+			memcpy(buf + 4, &in4->sin_addr, sizeof in4->sin_addr);
+			memcpy(buf + 8, &in4->sin_port, sizeof in4->sin_port);
+			wlen = 10;
+			break;
+		case AF_INET6:
+			/* Version 5, connect: IPv6 address */
+			buf[0] = SOCKS_V5;
+			buf[1] = SOCKS_CONNECT;
+			buf[2] = 0;
+			buf[3] = SOCKS_IPV6;
+			memcpy(buf + 4, &in6->sin6_addr, sizeof in6->sin6_addr);
+			memcpy(buf + 20, &in6->sin6_port,
+			    sizeof in6->sin6_port);
+			wlen = 22;
+			break;
+		default:
+			errx(1, "internal error: silly AF");
+		}
+
+		cnt = atomicio(vwrite, proxyfd, buf, wlen);
+		if (cnt != wlen)
+			err(1, "write failed (%zu/%zu)", cnt, wlen);
+
+		cnt = atomicio(read, proxyfd, buf, 4);
+		if (cnt != 4)
+			err(1, "read failed (%zu/4)", cnt);
+		if (buf[1] != 0)
+			errx(1, "connection failed, SOCKS error %d", buf[1]);
+		switch (buf[3]) {
+		case SOCKS_IPV4:
+			cnt = atomicio(read, proxyfd, buf + 4, 6);
+			if (cnt != 6)
+				err(1, "read failed (%zu/6)", cnt);
+			break;
+		case SOCKS_IPV6:
+			cnt = atomicio(read, proxyfd, buf + 4, 18);
+			if (cnt != 18)
+				err(1, "read failed (%zu/18)", cnt);
+			break;
+		default:
+			errx(1, "connection failed, unsupported address type");
+		}
+	} else if (socksv == 4) {
+		/* This will exit on lookup failure */
+		decode_addrport(host, port, (struct sockaddr *)&addr,
+		    sizeof(addr), 1, 0);
+
+		/* Version 4 */
+		buf[0] = SOCKS_V4;
+		buf[1] = SOCKS_CONNECT;	/* connect */
+		memcpy(buf + 2, &in4->sin_port, sizeof in4->sin_port);
+		memcpy(buf + 4, &in4->sin_addr, sizeof in4->sin_addr);
+		buf[8] = 0;	/* empty username */
+		wlen = 9;
+
+		cnt = atomicio(vwrite, proxyfd, buf, wlen);
+		if (cnt != wlen)
+			err(1, "write failed (%zu/%zu)", cnt, wlen);
+
+		cnt = atomicio(read, proxyfd, buf, 8);
+		if (cnt != 8)
+			err(1, "read failed (%zu/8)", cnt);
+		if (buf[1] != 90)
+			errx(1, "connection failed, SOCKS error %d", buf[1]);
+	} else if (socksv == -1) {
+		/* HTTP proxy CONNECT */
+
+		/* Disallow bad chars in hostname */
+		if (strcspn(host, "\r\n\t []:") != strlen(host))
+			errx(1, "Invalid hostname");
+
+		/* Try to be sane about numeric IPv6 addresses */
+		if (strchr(host, ':') != NULL) {
+			r = snprintf(buf, sizeof(buf),
+			    "CONNECT [%s]:%d HTTP/1.0\r\n",
+			    host, ntohs(serverport));
+		} else {
+			r = snprintf(buf, sizeof(buf),
+			    "CONNECT %s:%d HTTP/1.0\r\n",
+			    host, ntohs(serverport));
+		}
+		if (r == -1 || (size_t)r >= sizeof(buf))
+			errx(1, "hostname too long");
+		r = strlen(buf);
+
+		cnt = atomicio(vwrite, proxyfd, buf, r);
+		if (cnt != r)
+			err(1, "write failed (%zu/%d)", cnt, r);
+
+		if (authretry > 1) {
+			char resp[1024];
+
+			proxypass = getproxypass(proxyuser, proxyhost);
+			r = snprintf(buf, sizeof(buf), "%s:%s",
+			    proxyuser, proxypass);
+			if (r == -1 || (size_t)r >= sizeof(buf) ||
+			    b64_ntop(buf, strlen(buf), resp,
+			    sizeof(resp)) == -1)
+				errx(1, "Proxy username/password too long");
+			r = snprintf(buf, sizeof(buf), "Proxy-Authorization: "
+			    "Basic %s\r\n", resp);
+			if (r == -1 || (size_t)r >= sizeof(buf))
+				errx(1, "Proxy auth response too long");
+			r = strlen(buf);
+			if ((cnt = atomicio(vwrite, proxyfd, buf, r)) != r)
+				err(1, "write failed (%zu/%d)", cnt, r);
+		}
+
+		/* Terminate headers */
+		if ((cnt = atomicio(vwrite, proxyfd, "\r\n", 2)) != 2)
+			err(1, "write failed (%zu/2)", cnt);
+
+		/* Read status reply */
+		proxy_read_line(proxyfd, buf, sizeof(buf));
+		if (proxyuser != NULL &&
+		    strncmp(buf, "HTTP/1.0 407 ", 12) == 0) {
+			if (authretry > 1) {
+				fprintf(stderr, "Proxy authentication "
+				    "failed\n");
+			}
+			close(proxyfd);
+			goto again;
+		} else if (strncmp(buf, "HTTP/1.0 200 ", 12) != 0 &&
+		    strncmp(buf, "HTTP/1.1 200 ", 12) != 0)
+			errx(1, "Proxy error: \"%s\"", buf);
+
+		/* Headers continue until we hit an empty line */
+		for (r = 0; r < HTTP_MAXHDRS; r++) {
+			proxy_read_line(proxyfd, buf, sizeof(buf));
+			if (*buf == '\0')
+				break;
+		}
+		if (*buf != '\0')
+			errx(1, "Too many proxy headers received");
+	} else
+		errx(1, "Unknown proxy protocol %d", socksv);
+
+	return (proxyfd);
+}
diff --git a/usr.bin/newkey/Makefile b/usr.bin/newkey/Makefile
index 5b59c5c6a2..5b82f92ec8 100644
--- a/usr.bin/newkey/Makefile
+++ b/usr.bin/newkey/Makefile
@@ -13,6 +13,6 @@ LDADD=	-lrpcsvc
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 
 .include <bsd.prog.mk>
diff --git a/usr.bin/newkey/generic.c b/usr.bin/newkey/generic.c
index b2f3c68ced..74d6b2d947 100644
--- a/usr.bin/newkey/generic.c
+++ b/usr.bin/newkey/generic.c
@@ -74,7 +74,6 @@ itobn(long i)
 	if ((n = BN_new()) == NULL)
 		errx(1, "could not create BIGNUM: %s",
 		     ERR_error_string(ERR_get_error(), 0));
-	BN_init(n);
 	if (i > 0)
 		BN_add_word(n, (u_long)i);
 	else
diff --git a/usr.bin/openssl/Makefile b/usr.bin/openssl/Makefile
index 464a43050c..b21c9bba4c 100644
--- a/usr.bin/openssl/Makefile
+++ b/usr.bin/openssl/Makefile
@@ -1,27 +1,3 @@
-# This version of openssl(1) is from LibreSSL
-PROG=	openssl
-WARNS?=	2
-MAN=	openssl.1 openssl.cnf.5
+SUBDIR=	libapps openssl
 
-.include "${.CURDIR}/../../lib/librecrypto/Makefile.inc"
-
-CFLAGS+=	-DLIBRESSL_INTERNAL
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
-CFLAGS+= 	-I${.CURDIR}
-
-DPADD+=		${LIBSSL} ${LIBCRYPTO}
-LDADD+=		-lprivate_ssl -lprivate_crypto
-LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-
-SRCS=	apps_posix.c apps.c asn1pars.c ca.c certhash.c ciphers.c cms.c \
-	crl2p7.c crl.c \
-	dgst.c dh.c dhparam.c dsa.c dsaparam.c ec.c ecparam.c enc.c errstr.c \
-	gendh.c gendsa.c genpkey.c genrsa.c nseq.c ocsp.c openssl.c \
-	passwd.c pkcs12.c pkcs7.c pkcs8.c pkey.c pkeyparam.c pkeyutl.c \
-	prime.c rand.c req.c rsa.c rsautl.c \
-	s_cb.c s_client.c s_server.c s_socket.c s_time.c sess_id.c \
-	smime.c speed.c spkac.c ts.c verify.c version.c x509.c
-
-.include <bsd.prog.mk>
-
-.PATH:	${LIBRESSL_SRC}/apps/openssl ${LIBRESSL_SRC}/man
+.include <bsd.subdir.mk>
diff --git a/usr.bin/openssl/Makefile.etc b/usr.bin/openssl/Makefile.etc
index 2e1666f3fa..228f737b9d 100644
--- a/usr.bin/openssl/Makefile.etc
+++ b/usr.bin/openssl/Makefile.etc
@@ -4,6 +4,11 @@ FILESOWN=	${BINOWN}
 FILESGRP=	${BINGRP}
 FILESMODE=	644
 
-.include "../../lib/librecrypto/Makefile.inc"
-.PATH: ${LIBRESSL_SRC}/apps/openssl
+OPENSSL_SRC=	${.CURDIR}/../../crypto/openssl
+
+SCRIPTS=	CA.pl
+SCRIPTSDIR=	/etc/ssl
+
+.include "../../lib/libcrypto/Makefile.inc"
+.PATH: ${OPENSSL_SRC}/apps
 .include <bsd.prog.mk>
diff --git a/usr.bin/openssl/Makefile.inc b/usr.bin/openssl/Makefile.inc
new file mode 100644
index 0000000000..1f5b79aa2c
--- /dev/null
+++ b/usr.bin/openssl/Makefile.inc
@@ -0,0 +1,3 @@
+WARNS?=	2
+
+.include "../Makefile.inc"
diff --git a/usr.bin/openssl/libapps/Makefile b/usr.bin/openssl/libapps/Makefile
new file mode 100644
index 0000000000..ad41e9f29e
--- /dev/null
+++ b/usr.bin/openssl/libapps/Makefile
@@ -0,0 +1,14 @@
+LIB=		apps
+INTERNALLIB=
+CFLAGS+=	${PRIVATELIB_CFLAGS}
+CFLAGS+=	-I${OPENSSL_SRC} -I${OPENSSL_SRC}/include
+CFLAGS+=	-I${OPENSSL_SRC}/apps/include
+
+OPENSSL_SRC=	${.CURDIR}/../../../crypto/openssl
+
+.PATH:	${OPENSSL_SRC}/apps/lib
+
+SRCS=	app_libctx.c app_params.c app_provider.c app_rand.c apps.c apps_ui.c app_x509.c columns.c engine.c engine_loader.c fmt.c http_server.c names.c opt.c
+SRCS+=	s_cb.c s_socket.c tlssrp_depr.c
+
+.include <bsd.lib.mk>
diff --git a/usr.bin/openssl/openssl/Makefile b/usr.bin/openssl/openssl/Makefile
new file mode 100644
index 0000000000..905003def1
--- /dev/null
+++ b/usr.bin/openssl/openssl/Makefile
@@ -0,0 +1,27 @@
+# This version of openssl(1) is from LibreSSL
+PROG=	openssl
+#MAN=	openssl.1 openssl.cnf.5
+NOMAN=
+
+OPENSSL_SRC=	${.CURDIR}/../../../crypto/openssl
+
+.PATH:	${OPENSSL_SRC}/apps ${OPENSSL_SRC}/apps/lib ${OPENSSL_SRC}/man
+
+.if exists(${.OBJDIR}/../libapps)
+LIBAPPS=${.OBJDIR}/../libapps/libapps.a
+.else
+LIBAPPS=${.CURDIR}/../libapps/libapps.a
+.endif
+
+CFLAGS+=	${PRIVATELIB_CFLAGS}
+CFLAGS+=	-I${OPENSSL_SRC} -I${OPENSSL_SRC}/include
+CFLAGS+=	-I${OPENSSL_SRC}/apps/include
+CFLAGS+= 	-Wa,--noexecstack
+
+DPADD+=		${LIBSSL} ${LIBCRYPTO} ${LIBPTHREAD} ${LIBAPPS}
+LDADD+=		-lprivate_ssl -lprivate_crypto -lpthread ${LIBAPPS}
+LDFLAGS+=	${PRIVATELIB_LDFLAGS}
+
+SRCS=	cmp_mock_srv.c  asn1parse.c ca.c  ciphers.c cmp.c  cms.c crl.c  crl2pkcs7.c dgst.c  dhparam.c dsa.c  dsaparam.c ec.c  ecparam.c enc.c  engine.c errstr.c  fipsinstall.c gendsa.c  genpkey.c genrsa.c  info.c kdf.c  list.c mac.c  nseq.c ocsp.c  openssl.c passwd.c  pkcs12.c pkcs7.c  pkcs8.c pkey.c  pkeyparam.c pkeyutl.c  prime.c progs.c  rand.c rehash.c  req.c rsa.c  rsautl.c s_client.c  s_server.c s_time.c  sess_id.c smime.c  speed.c spkac.c  srp.c storeutl.c  ts.c verify.c  version.c x509.c
+
+.include <bsd.prog.mk>
diff --git a/usr.bin/scp/Makefile b/usr.bin/scp/Makefile
index 6b8c21fd07..9852e4e53b 100644
--- a/usr.bin/scp/Makefile
+++ b/usr.bin/scp/Makefile
@@ -8,7 +8,7 @@ SRCS+=	sftp-common.c sftp-client.c sftp-glob.c
 WARNS?=	3
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/usr.bin/sort/Makefile b/usr.bin/sort/Makefile
index 4f2c164adb..bfd3766519 100644
--- a/usr.bin/sort/Makefile
+++ b/usr.bin/sort/Makefile
@@ -12,6 +12,7 @@ SRCS=	bwstring.c \
 CFLAGS+= -DWITHOUT_NLS
 
 .if !defined(BOOTSTRAPPING) && !defined(RESCUE)
+CFLAGS+= -DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+= -DSORT_RANDOM
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD+=		${LIBCRYPTO}
diff --git a/usr.bin/ssh-add/Makefile b/usr.bin/ssh-add/Makefile
index bcb3a4165e..c339c11fa0 100644
--- a/usr.bin/ssh-add/Makefile
+++ b/usr.bin/ssh-add/Makefile
@@ -5,7 +5,7 @@ PROG=	ssh-add
 WARNS?=	3
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/usr.bin/ssh-agent/Makefile b/usr.bin/ssh-agent/Makefile
index dbe37db730..3b9b8042a9 100644
--- a/usr.bin/ssh-agent/Makefile
+++ b/usr.bin/ssh-agent/Makefile
@@ -8,7 +8,7 @@ WARNS?=	3
 # not needed: ssh-pkcs11-client.c
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/usr.bin/ssh-keygen/Makefile b/usr.bin/ssh-keygen/Makefile
index e4f6473886..729796c452 100644
--- a/usr.bin/ssh-keygen/Makefile
+++ b/usr.bin/ssh-keygen/Makefile
@@ -5,7 +5,8 @@ PROG=	ssh-keygen
 WARNS?=	3
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 DPADD=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/usr.bin/ssh-keyscan/Makefile b/usr.bin/ssh-keyscan/Makefile
index cc1719034e..bd7042db18 100644
--- a/usr.bin/ssh-keyscan/Makefile
+++ b/usr.bin/ssh-keyscan/Makefile
@@ -5,7 +5,7 @@ PROG=	ssh-keyscan
 WARNS?=	3
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/usr.bin/ssh/Makefile b/usr.bin/ssh/Makefile
index f350a04e25..0a2db97c24 100644
--- a/usr.bin/ssh/Makefile
+++ b/usr.bin/ssh/Makefile
@@ -16,7 +16,7 @@ CFLAGS+= -DXAUTH_PATH=\"${XAUTH_PATH}\"
 .endif
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/usr.bin/telnet/Makefile b/usr.bin/telnet/Makefile
index 9d141c1b49..9da9d73af7 100644
--- a/usr.bin/telnet/Makefile
+++ b/usr.bin/telnet/Makefile
@@ -22,7 +22,7 @@ CFLAGS+=	-I${_SHLIBDIRPREFIX}/usr/include/priv/ncurses
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
 
 CFLAGS+=	-DENCRYPTION -DAUTHENTICATION
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD+=		${LIBCRYPTO} ${LIBCRYPT}
 LDADD+=		-lprivate_crypto -lcrypt
 
diff --git a/usr.sbin/802_11/Makefile.crypto b/usr.sbin/802_11/Makefile.crypto
index 5c86dbc164..b39159aa0e 100644
--- a/usr.sbin/802_11/Makefile.crypto
+++ b/usr.sbin/802_11/Makefile.crypto
@@ -3,8 +3,9 @@
 SRCS+=		crypto_openssl.c random.c sha1-prf.c sha256-prf.c
 DPADD+=		${LIBSSL} ${LIBCRYPTO}
 LDADD+=		-lprivate_ssl -lprivate_crypto
-CFLAGS+= 	-DCONFIG_SHA256 -I${.CURDIR}/../../../crypto/libressl/include
+CFLAGS+= 	-DCONFIG_SHA256 -I${.CURDIR}/../../../crypto/openssl/include
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 
 .if defined(TLS_FUNCS)
 NEED_TLS_PRF=y
diff --git a/usr.sbin/ckdist/Makefile b/usr.sbin/ckdist/Makefile
index 0e857e79f0..f1f48c1d18 100644
--- a/usr.sbin/ckdist/Makefile
+++ b/usr.sbin/ckdist/Makefile
@@ -5,7 +5,7 @@
 PROG=	ckdist
 SRCS=   ckdist.c crc.c
 
-
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD=		${LIBCRYPTO}
 LDADD=		-lprivate_crypto
diff --git a/usr.sbin/keyserv/Makefile b/usr.sbin/keyserv/Makefile
index 153fe87ae6..2488aa95e3 100644
--- a/usr.sbin/keyserv/Makefile
+++ b/usr.sbin/keyserv/Makefile
@@ -17,7 +17,7 @@ LDADD=	-lrpcsvc
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 
 RPCDIR=	${DESTDIR}/usr/include/rpcsvc
 
diff --git a/usr.sbin/mtree/Makefile b/usr.sbin/mtree/Makefile
index 9e77a15bc8..e3730861fc 100644
--- a/usr.sbin/mtree/Makefile
+++ b/usr.sbin/mtree/Makefile
@@ -19,6 +19,7 @@ SRCS+= getid.c
 
 .if !defined(BOOTSTRAPPING) && !defined(RESCUE)
 SRCS+= hash.c
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+= 	${PRIVATELIB_CFLAGS}
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
diff --git a/usr.sbin/pfctl/Makefile b/usr.sbin/pfctl/Makefile
index 1ddf2ac34f..9f0c1ab39b 100644
--- a/usr.sbin/pfctl/Makefile
+++ b/usr.sbin/pfctl/Makefile
@@ -16,6 +16,7 @@ DPADD=	${LIBM}
 
 WARNS?=	2
 
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
diff --git a/usr.sbin/ppp/Makefile b/usr.sbin/ppp/Makefile
index 1da54ad563..80de831a83 100644
--- a/usr.sbin/ppp/Makefile
+++ b/usr.sbin/ppp/Makefile
@@ -89,6 +89,7 @@ SRCS+=	netgraph.c
 
 NO_STRICT_ALIASING=
 
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD+=		${LIBCRYPTO}
 LDADD+=		-lprivate_crypto
diff --git a/usr.sbin/sshd/Makefile b/usr.sbin/sshd/Makefile
index fb5731cbcf..04056234d9 100644
--- a/usr.sbin/sshd/Makefile
+++ b/usr.sbin/sshd/Makefile
@@ -36,7 +36,8 @@ LDADD+=	-lcrypt ${MINUSLPAM}
 DPADD+=	${LIBCRYPT} ${LIBPAM}
 
 CFLAGS+=	-I${.CURDIR}/../../lib/libssh -I${.CURDIR}/../../crypto/openssh
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 DPADD+=		${LIBSSH} ${LIBCRYPTO} ${LIBUTIL} ${LIBZ}
 LDADD+=		-lprivate_ssh -lprivate_crypto -lutil -lz
 LDFLAGS+=	-rpath /usr/lib/priv ${PRIVATELIB_LDFLAGS}
diff --git a/usr.sbin/tcpdump/Makefile b/usr.sbin/tcpdump/Makefile
index 2a28a44da1..ec665ff932 100644
--- a/usr.sbin/tcpdump/Makefile
+++ b/usr.sbin/tcpdump/Makefile
@@ -84,7 +84,8 @@ LDADD=	-lpcap
 
 CFLAGS+=-DHAVE_LIBCRYPTO -DHAVE_OPENSSL_EVP_H \
 	-DHAVE_EVP_CIPHERINIT_EX -DHAVE_EVP_CIPHER_CTX_NEW
-CFLAGS+=-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=-DOPENSSL_SUPPRESS_DEPRECATED
+CFLAGS+=-I${.CURDIR}/../../crypto/openssl/include
 LDFLAGS+=${PRIVATELIB_LDFLAGS}
 DPADD+=	${LIBCRYPTO}
 LDADD+=	-lprivate_crypto
diff --git a/usr.sbin/uefisign/Makefile b/usr.sbin/uefisign/Makefile
index cbe1f483f8..af675b9664 100644
--- a/usr.sbin/uefisign/Makefile
+++ b/usr.sbin/uefisign/Makefile
@@ -7,6 +7,6 @@ MAN=	uefisign.8
 LDADD=	-lprivate_crypto
 DPADD=	${LIBCRYPTO}
 LDFLAGS+= ${PRIVATELIB_LDFLAGS}
-CFLAGS+= -I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+= -I${.CURDIR}/../../crypto/openssl/include
 
 .include <bsd.prog.mk>
-- 
2.32.0

